<?php
namespace Teknisa\DF\Modules\Relatorios\Factories;

use Doctrine\ORM\EntityManager;

class Dfe22000DetalhamentoNotasFiscaisManifestadaFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function findNrNSU($NRORG,$NRINSJURIEST,$DTINSNRNSU,$IDAMBIENTENFE) {
        
        $sql = "SELECT NRACESSONFE, SUBSTR(NRACESSONFE,7,14) AS CNPJEMIT, SUBSTR(NRACESSONFE,1,2) AS UFEMIT, SUBSTR(NRACESSONFE,3,4) AS DTEMIS,SUBSTR(NRACESSONFE,23,3) AS NRSER,
                        SUBSTR(NRACESSONFE,26,9) AS NRNUMNOTA, SUBSTR(NRACESSONFE,35,1) AS FORMEMIT, MAX(DTINSNRNSU) as DTINC,
                        NRINSJURIEST, IDAMBIENTENFE, COUNT(*)
                   FROM NSUNFE
                  WHERE NRACESSONFE IS NOT NULL
                    AND NRORG = :NRORG
                    AND NRINSJURIEST = :NRINSJURIEST
                    AND TO_CHAR(DTINSNRNSU, 'MM/YYYY') = :DTINSNRNSU
                    AND IDAMBIENTENFE = :IDAMBIENTENFE
                  GROUP BY NRACESSONFE,NRINSJURIEST, IDAMBIENTENFE ";

                     
        $params = array(
            "NRORG"         => $NRORG,
            "NRINSJURIEST"  => $NRINSJURIEST,
            "DTINSNRNSU"    => $DTINSNRNSU,
            "IDAMBIENTENFE" => $IDAMBIENTENFE
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $dataSet = $std->fetchAll();
    }
    
    
    public function findHistNSU($NRACESSONFE) {
        
        $sql = " SELECT *
                   FROM NSUNFE
                  WHERE NRACESSONFE IS NOT NULL
                    AND NRACESSONFE = :NRACESSONFE ";

                     
        $params = array( 
            "NRACESSONFE"  => $NRACESSONFE
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $dataSet = $std->fetchAll();
    }
}