<?php
namespace Teknisa\DF\Modules\Relatorios\Services;

use Zeedhi\Framework\DataSource\DataSet;
use \Setforms2\Shared\ORM\DateTime;

class Dfe23000ComprasRealizadas{

    protected $entityManager;

    public function __construct($entityManager){
        $this->entityManager = $entityManager;
    }

    public function buildDataSet($dataSourceName, $rows){
        $dataSet = new DataSet($dataSourceName, $rows);
        return $dataSet;
    }

    public function maskAply($produto, $nrorg){
        $paramGeral = $this->entityManager->getRepository('Teknisa\Model\Geral\Entities\Paramgeral')->findBy(array("nrorg" => $nrorg));
        $mascara = $paramGeral[0]->getCdpictprod();
        $j = 0;
        $newProduto = "";
        for ($i=0; $i < strlen($mascara); $i++) {
            if(substr($mascara, $i, 1) !== "."){
                $newProduto .= substr($produto, $j, 1);
                $j++;
            } else {
                $newProduto .= ".";
            }
        }
        return $newProduto;
    }
    
    public function buildValorTotal($rows){
        $totalvrtotal = 0;
        $totalqt      = 0;
        for($i = 0; count($rows) > $i; $i++){
            $totalvrtotal += $rows[$i]['VALORTOTAL'];
            $totalqt += $rows[$i]["QUANTIDADE"];
        }
        $index = count($rows);
        $rows[$index]['VALORTOTAL'] = $totalvrtotal;
        $rows[$index]['QUANTIDADE'] = $totalqt;
        $rows[$index]['NMPRODUTO']  = 'Soma';
        return $rows;
    }

    public function formatRowsByReportData($rows){
        for ($i = 0; $i < count($rows); $i++) {
            $rows[$i]['AGRUPA'] = $rows[$i]['MES'].substr($rows[$i]['DATA'], 5, 5);
        }
        return $rows;
    }
    
    public function formatRowsByReportProd($rows){
        for ($i = 0; $i < count($rows); $i++) {
            $rows[$i]['AGRUPA'] = $this->maskAply($rows[$i]['CDARVPROD'], $rows[$i]['NRORG']).'  '.$rows[$i]['NMPRODUTO'].'   '.$rows[$i]['SGUNIDADE'];
        }
        return $rows;
    }
}